#include<fstream>
using namespace std;

ifstream  fin("easydel.in");
ofstream fout("easydel.out");
char s[20002];
int t[20002],nt;
int colour_number, best_effort, q[30][30], qtr[30][30], nr[30], ap[30];
int x[30];

void calcul(){
    int i,j,k;
    //q[a][b] = cu cat se misca spre stanga cuburile de culoare a daca se sterg cuburile de culoare b
    for(i=0;i<nt;i++){
        k=t[i];
        nr[k]++;
        for(j=0;j<colour_number;j++){
            if(j!=k)
                q[k][j]+=nr[j];
        }
    }
    for(i=0;i<colour_number;i++){
        for(j=0;j<colour_number;j++){
            qtr[i][j] = q[j][i];
        }
    }
}

void solve(int k, int effort){
    int i, j, ef, aux;
    if(k==colour_number){
        if(effort>best_effort){
            best_effort = effort;
        }
    }
    else{
        aux = x[k];
        ef = 0;
        for(j=k+1;j<colour_number;j++){
            ef += qtr[aux][x[j]];
        }
        solve(k+1,effort + ef);
        for(i=k;i<colour_number;i++){
            aux = x[i]; x[i] = x[k]; x[k] = aux;
            ef = 0;
            for(j=k+1;j<colour_number;j++){
                ef += qtr[aux][x[j]];
            }
            solve(k+1,effort + ef);
            x[k] = x[i]; x[i] = aux;
        }

    }

}

int main(){
    int i,j;
    fin>>s;
    for(i=0;i<=20;i++)ap[i]=-1;
    colour_number=0;
    for(i=0;s[i]!=0;i++){
        j=s[i]-48;
        if(ap[j]==-1){
            ap[j]=colour_number;
            t[i]=colour_number;
            colour_number++;
        }
        else{
            t[i]=ap[j];
        }
    }
    nt=i;
    //am redenumit culorile in ordinea in care se intalnesc , de la stanga spre dreapta
	//ca sa am spatiu compact de etichete de culori 1,2,...,colour_number
    calcul();
    best_effort=0;
    for(i=0;i<colour_number;i++){
        x[i]=i;
    }
    solve(0,0);
    fout<<best_effort<<"\n";
    fout.close();
    fin.close();
    return 0;
}


