#include<fstream>
using namespace std;

ifstream  fin("easydel.in");
ofstream fout("easydel.out");
char s[20002];
int t[20002],nt;
int colour_number, best_effort, q[30][30], qtr[30][30], nr[30], ap[30];
int viz[30];

void calcul(){
    int i,j,k;
    //q[a][b] = cu cat se misca spre stanga cuburile de culoare a daca se sterg cuburile de culoare b
    for(i=0;i<nt;i++){
        k=t[i];
        nr[k]++;
        for(j=0;j<colour_number;j++){
            if(j!=k)
                q[k][j]+=nr[j];
        }
    }
    for(i=0;i<colour_number;i++){
        for(j=0;j<colour_number;j++){
            qtr[i][j] = q[j][i];
        }
    }
}

void solve(int k, int effort){
    int i, j, ef;
    if(k==colour_number+1){
        if(effort>best_effort){
            best_effort = effort;
        }
    }
    else{
        for(i=0;i<colour_number;i++){
            if(viz[i]==0){
                //culoarea i inca nu a fost stearsa
                viz[i] = 1;
                ef = 0;
                for(j=0;j<colour_number;j++){
                    if(viz[j]==0){
                        ef += qtr[i][j];
                    }
                }
                solve(k+1,effort + ef);
                viz[i] = 0;
            }

        }

    }

}

int main(){
    int i,j;
    fin>>s;
    for(i=0;i<=20;i++)ap[i]=-1;
    colour_number=0;
    for(i=0;s[i]!=0;i++){
        j=s[i]-48;
        if(ap[j]==-1){
            ap[j]=colour_number;
            t[i]=colour_number;
            colour_number++;
        }
        else{
            t[i]=ap[j];
        }
    }
    nt=i;
    //am redenumit culorile in ordinea in care se intalnesc , de la stanga spre dreapta
	//ca sa am spatiu compact de etichete de culori 1,2,...,colour_number
    calcul();
    best_effort=0;
    solve(1,0);
    fout<<best_effort<<"\n";
    fout.close();
    fin.close();
    return 0;
}

