// O(n * C * 2^C)     C - nr de cifre distincte
#include <fstream>
#include <algorithm>
#include <string>

using namespace std;

const int Mask = (1 << 10), MaxN = 20005, MaxC = 11;
short b[MaxN];
int nr[Mask][MaxC];
int cnt[MaxC][MaxN];
bool s[MaxN];

int main()
{
    ifstream fin("easydel.in");
    ofstream fout("easydel.out");

	string a;
	getline(fin, a);
	int n = a.length();

	short mx(-1);
	for (int i = 0; i < n; ++i)
    {
		b[i] = a[i] - '0';
		mx = max(mx, b[i]);
		cnt[b[i]][i] = 1;
		s[b[i]] = true;
    }

    for (int i = 1; i < n; ++i)
        for (int c = 0; c <= mx; ++c)
			if ( s[c] )
				cnt[c][i] += cnt[c][i - 1];

	int msk(0), C[Mask][MaxC] = { 0 };

	for (int c = 0; c <= mx; ++c)
		if ( s[c] )
			msk |= 1 << c;

	for (int i = 0; i < msk; ++i)
		for (int c = 0; c <= mx; ++c)
			if ( i & (1 << c) )
				for (int j = 0; j < n; ++j)
					if ( !(i & (1 << b[j])) )
						C[i][c] += cnt[c][j];

	for (int i = 0; i < msk; ++i)
		for (int p = 0; p <= mx; ++p)
			if ( s[p] && !(i & (1 << p)) )
			{
				for (int k = 0; k <= mx; ++k)
					if ( s[k] && ((1 << k) & i) )
						nr[i | (1 << p)][p] = max(nr[i | (1 << p)][p], nr[i][k]);

				nr[i | (1 << p)][p] += C[i | (1 << p)][p];
			}

	int ans(0);
	for (int i = 0; i <= mx; ++i)
		if ( s[i] )
			for (int c = 0; c <= mx; ++c)
				if ( s[c] && c != i)
					ans = max(ans, nr[msk ^(1 << i)][c]);


	fout << ans;

	fin.close();
	fout.close();
}
